use utf8;

+{
	v5.6 => {
		new => [
			['<code>use warnings</code>', 'pragma to enable warnings in lexical scope'],
			['<code>use utf8</code>', 'experimental unicode semantics <small>(completed in v5.8)</small>', v5.8],
			['<code>use charnames</code>', 'string escape <code>\N{}</code> to insert named character'],
			['<code>our</code>', 'declare global variables'],
			['<code>v1.2.3</code>', q"represent strings as vector of ordinals, useful in version numbers (<code>printf '%vd'</code> to display)"],
			['<code>0b0</code>', q"binary numbers in literals, <code>printf '%b'</code>, and <code>oct</code>"],
			['<code>sub :lvalue</code>', 'subroutine attribute to return a modifiable value', v5.20],
#			['<code>sub :locked :method</code>', 'syntax to declare subroutine attributes'], # can be inferred from :lvalue support
			['<code>open my $fh, $mode, $expr</code>', 'file handles in scoped scalars, third argument for unambiguous file name'],
			[q"<code>pack 'q'</code>", '64-bit integer support (also large files &gt;2GiB)', v5.8.1],
			['<code>sort $coderef ()</code>', 'comparison function can be a subroutine reference; prototype <code>($$)</code> to pass elements as normal <code>@_</code>'],
			['<code>CHECK {}</code>', 'special block called at end of compilation'],
			['<code>/[[:…:]]/</code>', 'POSIX character class syntax such as <code>/[[:alpha:]]/</code>'],
			# quite a lot more, but leave it at this
		],
		release => '2000-03-23',
		distro => {
			debian => 'woody',
			rhel => '2', # v5.6.0; also in red hat 7.0
			solaris => '9', # v5.6.1; 2002-05 eol 2014-10
		},
		unicode => '3.0.1',
	},

	v5.8 => {
		new => [
			[q"<code>no utf8</code>", 'full unicode support, <code>utf8</code> pragma only for script encoding'],
			[q"<code>binmode $fh, ':perlio'</code>", 'file handle behaviour altered by PerlIO layers'],
			[q"<code>open $fh, '-|', @cmd</code>", 'open list to fork a command without spawning a shell'],
			[q"<code>open $fh, '>', \$var</code>", 'perl scalars as virtual files'],
			[q"<code>printf '%1$s', @args</code>", 'syntax to use parameters out of order'],
			[q"<code>1_2_3 == 123</code>", 'underscores between digits allowed in numeric constants'],
#			[q"<code>use if</code>", 'conditional module inclusion'], # also installable in earlier versions
		],
		release => '2002-07-18',
		distro => {
			debian => 'sarge',
			rhel => '3', # v5.8.0; v5.8.8 in RHEL6 (2007-2014)
			solaris => '10', # v5.8.4; 2005-01 eol 2021-01
			centos => '3-5', # v5.8.0 in v3 (2004-03); v5.8.8 in v5 (eol 2017-03)
		},
		unicode => '3.2.0',
	},

	v5.10 => {
		new => [
			['<code>//</code>', 'defined-or operator'],
			['<code>~~</code>', 'smart-match operator to compare different data types <small>(updated in v5.10.1)</small>', 'experimental::smartmatch'],
			['<code>given</code>', 'switch statement to smart-match with <code>when</code>/<code>default</code>', 'experimental::smartmatch'],
			['<code>/(?&lt;name>)/</code>', 'named capture buffers into <code>%+</code>'],
			['<code>s/keep\K//</code>', 'floating positive lookbehind, efficient alternative for <code>s/(keep)/$1/</code>'],
			['<code>/\v/, /\h/</code>', 'vertical and horizontal whitespace escapes'],
			['<code>my $_</code>', 'lexically scoped version of the default variable', 'experimental::lexical_topic'],
		],
		release => '2007-12-18',
		distro => {
			debian => 'lenny',
			rhel => '6', # v5.10.1
			centos => '6', # v5.10.1 (2011-07 eol 2020-11)
		},
		unicode => '5.0.0',
	},

	v5.12 => {
		new => [
			['<code>package version</code>', '<code>package</code> NAME VERSION shorthand for <code>our $VERSION</code>'],
			['<code>...</code>', 'yada-yada operator: code placeholder'],
			['<code>use 5.012</code>', 'Implicit <code>strict</code> if use VERSION >= v5.12'],
			['<code>… when</code>', '<code>when</code> is now allowed to be used as a statement modifier'],
			[q"<code>use overload 'qr'</code>", 'customisable conversion to regular expressions'],
			['<code>/\N/</code>', 'inverse \n to match any character except newline regardless of <code>/s</code>', v5.18],
		],
		release => '2010-04-12',
		unicode => '5.2',
		distro => {
			solaris => '11', # also v5.8.4; 2010-11 eol 2024-11
		},
	},

	v5.14 => {
		new => [
			['<code>s///r</code>', 'non-destructive substitution'],
			['<code>/(?^)/</code>', 'construct to reset to default modifiers'],
			['<code>/(?{ m() })/</code>', 'regular expressions can be nested in <code>/(?{})/</code> and <code>/(??{})/</code>', v5.20],
			[q"<code>use re '/flags'</code>", 'customise default modifiers'],
			['<code>each $ref</code> e.a.', 'array and hash container functions accept references', v0.5.23.1],
			['<code>FH->method</code>', 'filehandle method calls load IO::File on demand (eg. <code>STDOUT->flush</code>)'],
		],
		release => '2011-05-14',
		distro => {
			debian => 'wheezy',
		},
		unicode => '6.0+#8',
	},

	v5.16 => {
		new => [
			['<code>__SUB__</code>', 'current subroutine reference'],
			['<code>fc, "\F"</code>', 'unicode foldcase to compare case-insensitively'],
			['<code>"\N{}"</code>', 'automatic <code>use charnames qw( :full :short )</code>'],
		],
		release => '2012-05-20',
		distro => {
			rhel => '7', # v5.16.3
			centos => '7', # v5.16.3 (2014-07 eol 2024-06)
		},
		unicode => '6.1',
	},

	v5.18 => {
		new => [
			['<code>${^LAST_FH}</code>', 'last read filehandle (used by <code>$.</code>)'],
			['<code>/(?[ a + b ])/</code>', 'regex set operations (character substraction <code>-</code>, unions <code>&amp;</code>)', 'experimental::regex_sets'],
			['<code>my sub</code>', 'lexical subroutines (also <code>state</code>, <code>our</code>)', 'experimental::lexical_subs'],
			['<code>next $expression</code>', 'loop controls allow runtime expressions'],
			[q"<code>no warnings 'experimental::…'</code>", 'mechanism for experimental features, as of now required for smartmatch'],
		],
		release => '2013-05-18',
		unicode => '6.2',
	},

	v5.20 => {
		new => [
			['<code>sub ($var)</code>', 'subroutine signatures', 'experimental::signatures'],
			['<code>%hash{…}</code>', 'hash slices return key+value pairs'],
			['<code>[]->@*</code>', 'postfix dereferencing (also e.g. <code>$scalar->$*</code> for <code>$$scalar</code>)', v5.23.1, 'experimental::postderef'],
			[q"<code>use warnings 'once'; $a</code>", 'variables $a and $b are exempt from <em>used once</em> warnings'],
		],
		unicode => '6.3',
		release => '2014-05-27',
		distro => {
			debian => 'jessie',
		},
	},

	v5.22 => {
		new => [
			['<code>\$alias =</code>', 'aliasing via reference'],
			['<code>&lt;&lt;>></code>', 'safe <code>readline</code> ignoring open flags in arguments'],
			['<code>/()/n</code>', 'flag to disable numbered capturing, turning <code>()</code> into <code>(?:)</code>'],
			['<code>/\b{}/</code>', 'boundary types: <em>gcb</em> (grapheme cluster), <em>sb</em> (sentence), <em>wb</em> (word)'],
			['<code>&.</code>', '<code>& | ^ ~</code> consistently numeric, dotted operators for strings', 'experimental::bitwise'],
			[q"<code>use re 'strict'</code>", 'apply stricter syntax rules to regular expression patterns', 'experimental::re_strict'],
			['<code>0x.beep+0</code>', q"hexadecimal floating point notation with binary power; <code>printf '%a'</code> to display"],
		],
		unicode => '7.0',
		release => '2015-06-01',
	},
}
